package net.lesscoding.handmade.utils;

import cn.hutool.captcha.generator.RandomGenerator;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author eleven
 * @date 2023/7/20 14:56
 * @apiNote
 */
public class OrderNoUtil {
    /**
     * 生成随机订单号
     * 精确到毫秒的数据 + 6位随机码
     * @return  String 23位长度
     */
    public static String generateOrderNo() {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMMddHHmmssSSS");
        String format = LocalDateTime.now().format(formatter);
        return format + new RandomGenerator("0123456789", 6).generate();
    }

    public static String genSubOrder(String orderNo, Integer index) {
        return String.format("%s-%02d", orderNo, index);
    }

    public static void main(String[] args) {
        String orderNo = generateOrderNo();
        System.out.println(orderNo);
        System.out.println(genSubOrder(orderNo, 9));
    }
}
